/*!
@ng-dynamic-forms/ui-bootstrap 5.4.7 2018-03-16 23:20 UTC
Copyright (c) 2016-2017, Udo Schöfer http://www.udos86.de

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ng-dynamic-forms/core'), require('@angular/common'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap/timepicker'), require('angular2-text-mask')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@ng-dynamic-forms/core', '@angular/common', 'ngx-bootstrap/datepicker', 'ngx-bootstrap/timepicker', 'angular2-text-mask'], factory) :
	(factory((global.ngDF = global.ngDF || {}, global.ngDF.bootstrapUI = {}),global.ng.core,global.ng.forms,global.ngDF.core,global.ng.common,global['ngx-bootstrap'].umd,global['ngx-bootstrap'].umd,global['angular2-text-mask']));
}(this, (function (exports,core,forms,core$1,common,datepicker,timepicker,angular2TextMask) { 'use strict';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var DynamicBootstrapFormControlComponent = /** @class */ (function (_super) {
    __extends(DynamicBootstrapFormControlComponent, _super);
    function DynamicBootstrapFormControlComponent(changeDetectorRef, layoutService, validationService) {
        var _this = _super.call(this, changeDetectorRef, layoutService, validationService) || this;
        _this.changeDetectorRef = changeDetectorRef;
        _this.layoutService = layoutService;
        _this.validationService = validationService;
        _this.asBootstrapFormGroup = true;
        _this.bindId = true;
        _this.context = null;
        _this.hasErrorMessaging = false;
        _this.blur = new core.EventEmitter();
        _this.change = new core.EventEmitter();
        _this.focus = new core.EventEmitter();
        _this.customEvent = new core.EventEmitter();
        return _this;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    DynamicBootstrapFormControlComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
        if (changes["model"]) {
            this.type = DynamicBootstrapFormControlComponent.getFormControlType(this.model);
        }
    };
    /**
     * @param {?} model
     * @return {?}
     */
    DynamicBootstrapFormControlComponent.getFormControlType = /**
     * @param {?} model
     * @return {?}
     */
    function (model) {
        switch (model.type) {
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return 1 /* Array */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return 2 /* Checkbox */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return 4 /* Group */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return 3 /* DatePicker */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return 5 /* Input */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return 6 /* RadioGroup */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return 7 /* Select */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return 8 /* TextArea */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TIMEPICKER:
                return 9 /* TimePicker */;
            default:
                return null;
        }
    };
    DynamicBootstrapFormControlComponent.decorators = [
        { type: core.Component, args: [{
                    selector: "dynamic-bootstrap-form-control,dynamic-form-bootstrap-control",
                    template: "<div [class.form-group]=\"asBootstrapFormGroup || getClass('element', 'container').includes('form-group')\" [class.has-error]=\"showErrorMessages\" [formGroup]=\"group\" [ngClass]=\"[getClass('element', 'container'), getClass('grid', 'container')]\"><label *ngIf=\"type !== 2 && model.label\" [for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></label><ng-container *ngTemplateOutlet=\"templates[0]?.templateRef; context: model\"></ng-container><div *ngIf=\"type === 2\" [ngClass]=\"getClass('grid', 'control')\"><div [class.disabled]=\"model.disabled\" [ngClass]=\"getClass('element', 'control') || 'checkbox'\"><label><input type=\"checkbox\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [indeterminate]=\"model.indeterminate\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [required]=\"model.required\" [tabindex]=\"model.tabIndex\" [value]=\"model.value\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"><span [innerHTML]=\"model.label\" [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></span></label></div></div><div *ngIf=\"type !== 2\" [ngClass]=\"getClass('grid', 'control')\"><ng-container [ngSwitch]=\"type\"><div *ngSwitchCase=\"1\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"getClass('element', 'control')\"><div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\" [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\"><dynamic-bootstrap-form-control *ngFor=\"let _model of groupModel.group\" [bindId]=\"false\" [context]=\"groupModel\" [group]=\"control.at(idx)\" [hasErrorMessaging]=\"_model.hasErrorMessages\" [hidden]=\"_model.hidden\" [layout]=\"layout\" [model]=\"_model\" [templates]=\"templateList\" [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model)]\" (dfBlur)=\"onBlur($event)\" (dfChange)=\"onValueChange($event)\" (dfFocus)=\"onFocus($event)\"></dynamic-bootstrap-form-control><ng-container *ngTemplateOutlet=\"templates[2]?.templateRef; context: groupModel\"></ng-container></div></div><div *ngSwitchCase=\"3\" class=\"input-group\"><input bsDatepicker class=\"form-control\" #bsDatepicker=\"bsDatepicker\" [autofocus]=\"model.autoFocus\" [bsConfig]=\"getAdditional('bsConfig', {containerClass: getAdditional('containerClass', 'theme-green'), showWeekNumbers: getAdditional('showWeekNumbers', true)})\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxDate]=\"model.max\" [minDate]=\"model.min\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [outsideClick]=\"getAdditional('outsideClick', true)\" [placeholder]=\"model.placeholder\" [placement]=\"getAdditional('placement', 'bottom')\" [readonly]=\"model.readOnly\" [required]=\"model.required\" (bsValueChange)=\"onValueChange($event)\" (onHidden)=\"onCustomEvent($event, 'onHidden')\" (onShown)=\"onCustomEvent($event, 'onShown')\"><div *ngIf=\"model.toggleLabel\" class=\"input-group-btn\"><button *ngIf=\"model.toggleIcon\" class=\"btn\" (click)=\"bsDatepicker.toggle()\"><img [src]=\"model.toggleIcon\"></button> <button *ngIf=\"model.toggleLabel\" class=\"btn\" (click)=\"bsDatepicker.toggle()\">{{ model.toggleLabel }}</button></div></div><fieldset *ngSwitchCase=\"4\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><dynamic-bootstrap-form-control *ngFor=\"let _model of model.group\" [asBootstrapFormGroup]=\"false\" [group]=\"control\" [hasErrorMessaging]=\"_model.hasErrorMessages\" [hidden]=\"_model.hidden\" [layout]=\"layout\" [model]=\"_model\" [templates]=\"templateList\" [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model)]\" (dfBlur)=\"onBlur($event)\" (dfChange)=\"onValueChange($event)\" (dfFocus)=\"onFocus($event)\"></dynamic-bootstrap-form-control></fieldset><div *ngSwitchCase=\"5\" [class.input-group]=\"model.prefix || model.suffix\"><div *ngIf=\"model.prefix\" class=\"input-group-addon\" [innerHTML]=\"model.prefix\"></div><input class=\"form-control\" [attr.accept]=\"model.accept\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [autocomplete]=\"model.autoComplete\" [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\" [type]=\"model.inputType\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"><div *ngIf=\"model.suffix\" class=\"input-group-addon\" [innerHTML]=\"model.suffix\"></div><datalist *ngIf=\"hasList\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"6\" role=\"radiogroup\" [dynamicId]=\"bindId && model.id\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [tabindex]=\"model.tabIndex\" (change)=\"onValueChange($event)\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><div *ngFor=\"let option of model.options$ | async\" [ngClass]=\"getClass('element', 'option') || 'radio'\"><label><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [value]=\"option.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\"><span [innerHTML]=\"option.label\"></span></label></div></fieldset><select *ngSwitchCase=\"7\" class=\"form-control\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [required]=\"model.required\" [tabindex]=\"model.tabIndex\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"><option *ngFor=\"let option of model.options$ | async\" [disabled]=\"option.disabled\" [ngValue]=\"option.value\">{{ option.label }}</option></select> <textarea *ngSwitchCase=\"8\" class=\"form-control\" [dynamicId]=\"bindId && model.id\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [wrap]=\"model.wrap\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"></textarea> <span *ngIf=\"showHint\" class=\"help-block\" [innerHTML]=\"model.hint\" [ngClass]=\"getClass('element', 'hint')\"></span><timepicker *ngSwitchCase=\"9\" [arrowkeys]=\"getAdditional('arrowkeys', true)\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [hourStep]=\"getAdditional('hourStep', 1)\" [max]=\"model.max\" [min]=\"model.min\" [mousewheel]=\"getAdditional('mousewheel', true)\" [minuteStep]=\"getAdditional('minuteStep', 1)\" [ngClass]=\"getClass('element', 'control')\" [secondsStep]=\"getAdditional('secondsStep', 1)\" [showMeridian]=\"model.meridian\" [showSeconds]=\"model.showSeconds\" [showSpinners]=\"getAdditional('spinners', true)\"></timepicker></ng-container></div><ul *ngIf=\"showErrorMessages\" class=\"has-error\" [ngClass]=\"[getClass('element', 'errors'), getClass('grid', 'errors')]\"><li *ngFor=\"let message of errorMessages\" class=\"help-block\">{{ message }}</li></ul><ng-container *ngTemplateOutlet=\"templates[1]?.templateRef; context: model\"></ng-container><ng-content></ng-content></div>"
                },] },
    ];
    /** @nocollapse */
    DynamicBootstrapFormControlComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef, },
        { type: core$1.DynamicFormLayoutService, },
        { type: core$1.DynamicFormValidationService, },
    ]; };
    DynamicBootstrapFormControlComponent.propDecorators = {
        "contentTemplateList": [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] },],
        "inputTemplateList": [{ type: core.Input, args: ["templates",] },],
        "asBootstrapFormGroup": [{ type: core.Input },],
        "bindId": [{ type: core.Input },],
        "context": [{ type: core.Input },],
        "group": [{ type: core.Input },],
        "hasErrorMessaging": [{ type: core.Input },],
        "layout": [{ type: core.Input },],
        "model": [{ type: core.Input },],
        "blur": [{ type: core.Output, args: ["dfBlur",] },],
        "change": [{ type: core.Output, args: ["dfChange",] },],
        "focus": [{ type: core.Output, args: ["dfFocus",] },],
        "customEvent": [{ type: core.Output, args: ["bsEvent",] },],
    };
    return DynamicBootstrapFormControlComponent;
}(core$1.DynamicFormControlComponent));

var __extends$1 = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var DynamicBootstrapFormComponent = /** @class */ (function (_super) {
    __extends$1(DynamicBootstrapFormComponent, _super);
    function DynamicBootstrapFormComponent(formService, layoutService) {
        var _this = _super.call(this, formService, layoutService) || this;
        _this.formService = formService;
        _this.layoutService = layoutService;
        _this.blur = new core.EventEmitter();
        _this.change = new core.EventEmitter();
        _this.focus = new core.EventEmitter();
        return _this;
    }
    DynamicBootstrapFormComponent.decorators = [
        { type: core.Component, args: [{
                    selector: "dynamic-bootstrap-form",
                    template: "<dynamic-bootstrap-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\" [group]=\"formGroup\" [hasErrorMessaging]=\"model.hasErrorMessages\" [hidden]=\"model.hidden\" [layout]=\"formLayout\" [model]=\"model\" [ngClass]=\"[getClass(model,'element','host'), getClass(model,'grid','host')]\" [templates]=\"templates\" (dfBlur)=\"onEvent($event, 'blur')\" (dfChange)=\"onEvent($event, 'change')\" (dfFocus)=\"onEvent($event, 'focus')\"></dynamic-bootstrap-form-control>"
                },] },
    ];
    /** @nocollapse */
    DynamicBootstrapFormComponent.ctorParameters = function () { return [
        { type: core$1.DynamicFormService, },
        { type: core$1.DynamicFormLayoutService, },
    ]; };
    DynamicBootstrapFormComponent.propDecorators = {
        "formGroup": [{ type: core.Input, args: ["group",] },],
        "formModel": [{ type: core.Input, args: ["model",] },],
        "formLayout": [{ type: core.Input, args: ["layout",] },],
        "blur": [{ type: core.Output, args: ["dfBlur",] },],
        "change": [{ type: core.Output, args: ["dfChange",] },],
        "focus": [{ type: core.Output, args: ["dfFocus",] },],
        "templates": [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] },],
        "components": [{ type: core.ViewChildren, args: [DynamicBootstrapFormControlComponent,] },],
    };
    return DynamicBootstrapFormComponent;
}(core$1.DynamicFormComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DynamicFormsBootstrapUIModule = /** @class */ (function () {
    function DynamicFormsBootstrapUIModule() {
    }
    DynamicFormsBootstrapUIModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.ReactiveFormsModule,
                        datepicker.BsDatepickerModule.forRoot(),
                        timepicker.TimepickerModule.forRoot(),
                        angular2TextMask.TextMaskModule,
                        core$1.DynamicFormsCoreModule
                    ],
                    declarations: [
                        DynamicBootstrapFormControlComponent,
                        DynamicBootstrapFormComponent
                    ],
                    exports: [
                        core$1.DynamicFormsCoreModule,
                        DynamicBootstrapFormControlComponent,
                        DynamicBootstrapFormComponent
                    ]
                },] },
    ];
    /** @nocollapse */
    DynamicFormsBootstrapUIModule.ctorParameters = function () { return []; };
    return DynamicFormsBootstrapUIModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

exports.DynamicBootstrapFormComponent = DynamicBootstrapFormComponent;
exports.DynamicBootstrapFormControlComponent = DynamicBootstrapFormControlComponent;
exports.DynamicFormsBootstrapUIModule = DynamicFormsBootstrapUIModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ui-bootstrap.umd.js.map
